'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResilientComponent = function (_Component) {
  _inherits(ResilientComponent, _Component);

  function ResilientComponent(props) {
    _classCallCheck(this, ResilientComponent);

    // Make it backwards compatible for React < 16
    var _this = _possibleConstructorReturn(this, (ResilientComponent.__proto__ || Object.getPrototypeOf(ResilientComponent)).call(this, props));

    _this.unstable_handleError = _this.componentDidCatch;

    _this.state = {
      error: null,
      retries: 0
    };
    return _this;
  }

  _createClass(ResilientComponent, [{
    key: 'componentDidCatch',
    value: function componentDidCatch(error) {
      var onError = this.props.onError;


      this.setState(function (prevState) {
        return {
          error: error,
          retries: prevState.retries + 1
        };
      });

      onError && onError(error);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          error = _state.error,
          retries = _state.retries;
      var _props = this.props,
          children = _props.children,
          maxRetries = _props.maxRetries,
          onError = _props.onError,
          FallbackComponent = _props.FallbackComponent;


      return error && retries > maxRetries ? _react2.default.createElement(FallbackComponent, null) : children;
    }
  }]);

  return ResilientComponent;
}(_react.Component);

ResilientComponent.propTypes = {
  children: _propTypes2.default.node.isRequired,
  FallbackComponent: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  maxRetries: _propTypes2.default.number,
  onError: _propTypes2.default.func
};

ResilientComponent.defaultProps = {
  FallbackComponent: function FallbackComponent() {
    return null;
  },
  maxRetries: 0
};

exports.default = ResilientComponent;